#include "stdio.h" 
#include "stdlib.h"
#include "fcntl.h"
#include "gfal_api.h"

int main (int argc, char **argv)
{

int fd,cod_ex,i,br=0;
char *read_buffer,*str,c;
char *file_ref;
struct stat remote_file_stat;

  if (argc < 2)  {
       fprintf(stderr,"Argument unspecified\n");
       fprintf(stderr,"Usage : %s [ lfn | guid | srm]\n",argv[0]);
       exit (1);  
   } 
  else
      file_ref = argv[1];

  str=(char *)malloc(999);
  
  /* try opening the file in remote mode */
  if ((fd = gfal_open(file_ref, O_RDONLY, 0644)) < 0) {
      fprintf(stderr,"Unable to open file %s for reading : \n",file_ref);
      perror("gfal_open");
      exit(1);
  }
  else {
      fprintf(stderr,"File %s successfully opened\n",file_ref);  
  } 
  
  /* retrieve some stats on that (byte size) */
  if ((cod_ex = gfal_stat(file_ref,&remote_file_stat) < 0))
     perror ("gfal_stat");
  else {
       fprintf(stderr,"file size is %d\n",remote_file_stat.st_size);
       read_buffer=(char *)malloc(remote_file_stat.st_size);
       memset(read_buffer,0,remote_file_stat.st_size);
  }

  /* try to read it; bytes are copied on read buffer */
  if ((cod_ex = gfal_read(fd,read_buffer,remote_file_stat.st_size)) < 0 ) {
     perror("gfal_read");
     exit(1); 
  }
  else {
         fprintf (stderr,"Number of bytes read = %d \nFile %s initial content : \n",
                  cod_ex,file_ref);
         while (br < remote_file_stat.st_size) {
                 i=0;
                 /* copy each line on str buffer and print it */
                 while (((str[i++]=read_buffer[br++]) != '\n' ));
                 str[i]='\0';  
                 printf("%s",str);
                 memset(str,0,999);
         }
  }

   if ((cod_ex = gfal_close(fd)) < 0) {
       perror ("gfal_close");
   }
   else
       fprintf (stderr,"File %s successfully closed\n",file_ref);

  free(read_buffer);
  free(str);
  exit(0);
}

